#!/bin/sh
#
# Copyright (c) Semarchy.  All rights reserved.
#
# PRODUCT Semarchy xDI Runtime
#   
#	This script allows to execute several commands on a remote runtime.
#	When it is executed without any parameters it opens a prompt that allows the user to type commands dynamically.
#
#	The first command should always be a "connect" command.
#
#	Note:
#	To have an overview of the possible parameters, use the -usage parameter
#	
#	Examples:
#	startcommand.sh -usage
#	startcommand.sh "connect;help"
#	startcommand.sh "connect;versions"
#	startcommand.sh "connect;execute delivery mydeliv"
#

if [ "$XDI_RUNTIME_HOME" = "" ]; then
        XDI_RUNTIME_HOME=.
        export XDI_RUNTIME_HOME
fi


. $XDI_RUNTIME_HOME/initvariables.sh 


if [ "$STAMBIA_JAVA_HOME" = "" ]; then
        if [ "$JAVA_HOME" = "" ]; then
	        java $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTCOMMAND_VM_PROPERTIES $XDI_RUNTIME_SYSTEM_CLASSLOADER -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineCommandStartI -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
        else
                "$JAVA_HOME/bin/java" $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTCOMMAND_VM_PROPERTIES $XDI_RUNTIME_SYSTEM_CLASSLOADER -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineCommandStartI -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
        fi
else
	"$STAMBIA_JAVA_HOME/bin/java" $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTCOMMAND_VM_PROPERTIES $XDI_RUNTIME_SYSTEM_CLASSLOADER -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineCommandStartI -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
fi

